
model_fitting <-function(data, wrapper = 'SL.glm')
{
  set.seed(1)
  m_control <- SuperLearner(data$cd420[data$treat == 0], data[data$treat == 0, -c(2,14)],  SL.library = wrapper )
  set.seed(1)
  m_treatment <- SuperLearner(data$cd420[data$treat == 1], data[data$treat == 1, -c(2,14)],  SL.library = wrapper )
  
  #pred_m_control <- predict(m_control, covariates)
  # pred_m_treatment <- predict(m_treatment, covariates)
  #
  # ax<-pred_m_treatment$pred - pred_m_control$pred
  
  theta <- theta_aug(m_control, m_treatment, data)
  return(theta)
}

model_fitting2 <-function(data, wrapper = 'SL.glm')
{
  mm <- model.matrix(cd420~.^2 + I(cd40^2) + I(cd80^2) + I(age^2) + I(wtkg^2) + I(karnof^2), data = data[,-14])
  set.seed(1)
  m_control <- SuperLearner(data$cd420[data$treat == 0], mm[data$treat == 0, -c(1,14)],  SL.library = wrapper )
  set.seed(1)
  m_treatment <- SuperLearner(data$cd420[data$treat == 1], mm[data$treat == 1, -c(1,14)],  SL.library = wrapper )
  
  #pred_m_control <- predict(m_control, covariates)
  # pred_m_treatment <- predict(m_treatment, covariates)
  #
  # ax<-pred_m_treatment$pred - pred_m_control$pred
  
  theta <- theta_aug2(m_control, m_treatment, data.frame(cbind(cd420, treat, mm[,-c(1)])))
  return(theta)
}

#GLMNET WRAPPERS
SL.rf.glmnet_lasso1 = function(...) {
  SL.glmnet(..., alpha = 1, loss = 'mse',  nfolds = 10  )
}

SL.rf.glmnet_lasso2 = function(...) {
  SL.glmnet(..., alpha = 1, loss = 'mse',  nfolds = 20  )
}

SL.rf.glmnet_ridge1 = function(...) {
  SL.glmnet(..., alpha = 0,  loss = 'mse',  nfolds = 10   )
}

SL.rf.glmnet_ridge2 = function(...) {
  SL.glmnet(..., alpha = 0,  loss = 'mse',  nfolds = 20  )
}




#random forest

SL.rf.rforest.4.100 = function(...) {
  SL.randomForest(..., mtry = 4 , ntree =100 )
}

SL.rf.rforest.4.500 = function(...) {
  SL.randomForest(..., mtry = 4 , ntree =500 )
}

SL.rf.rforest.4.1000 = function(...) {
  SL.randomForest(..., mtry = 4 , ntree =1000 )
}


SL.rf.rforest.3.100 = function(...) {
  SL.randomForest(..., mtry = 3 , ntree =100 )
}

SL.rf.rforest.3.500 = function(...) {
  SL.randomForest(..., mtry = 3 , ntree =500 )
}

SL.rf.rforest.3.1000 = function(...) {
  SL.randomForest(..., mtry = 3 , ntree =1000 )
}
#######################################
#MODEL FITTING#
#######################################


#glmnet on all terms
model_fitting(newdata2, "SL.rf.glmnet_lasso1" )
model_fitting(newdata2, "SL.rf.glmnet_lasso2" )
model_fitting(newdata2, "SL.rf.glmnet_ridge1" )
model_fitting(newdata2, "SL.rf.glmnet_ridge2" )

#glmnet on full models
model_fitting2(newdata2, "SL.rf.glmnet_lasso1" )
model_fitting2(newdata2, "SL.rf.glmnet_lasso2" )
model_fitting2(newdata2, "SL.rf.glmnet_ridge1" )
model_fitting2(newdata2, "SL.rf.glmnet_ridge2" )

options(warn=0)

model_fitting(newdata2, "SL.rpart")

df75<-df_0.75[df_0.75$nsim]

set.seed(1)
m_control <- SuperLearner(data$cd420[data$treat == 0], newdata2[data$treat == 0, -c(1,14)],  SL.library = "SL.rpart" )
set.seed(1)
m<-rpart(cd420~., data= newdata[treat == 1, -c(14)])

rpart.plot(m)

#random forest
model_fitting(newdata2, "SL.rf.rforest.4.100" )
model_fitting(newdata2, "SL.rf.rforest.4.500" )
model_fitting(newdata2, "SL.rf.rforest.4.1000" )

model_fitting(newdata2, "SL.rf.rforest.3.100" )
model_fitting(newdata2, "SL.rf.rforest.3.500" )
model_fitting(newdata2, "SL.rf.rforest.3.1000" )


